/* vxbHpnfc.h - header for HPNFC driver */

/*
 * Copyright (c) 2012, 2021, 2023-2024 Wind River Systems, Inc.
 *
 * The right to copy, distribute, modify, or otherwise make use
 * of this software may be licensed only pursuant to the terms
 * of an applicable Wind River license agreement.
 */

#ifndef __INCvxbHpnfch
#define __INCvxbHpnfch

#ifdef  __cplusplus
 extern "C" {
#endif

#define HPNFC_DRV_NAME   "hpnfc"

/* platform type (currently not used) */

typedef enum hpnfc_plat_type
   {
   HPNFC_PLAT_SOCFPGA_AGILEX5_SOCDK = 1,    /* Intel Agilex5 Simic Model */
   } HPNFC_PLAT_TYPE;

/* FDT flag defines */

#define HPNFC_FLAG_PFPWDIS   0x01    /* Prefecth/Postwrite engine disabled */
#define HPNFC_FLAG_DMADIS    0x02    /* DMA disabled */
#define HPNFC_FLAG_CACHEDIS  0x04    /* NAND Cache disabled */
#define HPNFC_FLAG_ZCOPYDIS  0x08    /* zero-copy disabled */
#define HPNFC_FLAG_INTDIS    0x10    /* interrupt disabled (poll instead) */

#ifdef  __cplusplus
}
#endif

#endif /* __INCvxbhpnfch */
