/* auxClkTest.c - Test aux. clock */

#include <vxWorks.h>
#include <sysLib.h>
#include <edrLib.h>

#include <stdlib.h>
#include <stdio.h>
#include <string.h>


LOCAL UINT32 intCount = 0;
LOCAL BOOL connected = FALSE;

LOCAL int auxClkCallback
    (
    _Vx_usr_arg_t arg
    )
    {
    intCount++;
    return 0;
    }

STATUS auxClkTest
    (
    int secs
    )
    {
    STATUS rc;

    if (secs <= 0)
        {
        secs = 5;
        }

    intCount = 0;

    if (!connected)
        {
        rc = sysAuxClkConnect((FUNCPTR) auxClkCallback, 0);
        if (rc != OK)
            {
            printf("sysAuxClkConnect() fails\n");
            return ERROR;
            }
        }

    connected = TRUE;
    printf("Starting (%d secs)...\n", secs);
    sysAuxClkEnable();
    for (;;)
        {
        if (intCount >= (sysAuxClkRateGet() * secs))
            {
            break;
            }
        }

    printf("done\n");
    sysAuxClkDisable();

    return OK;
    }
