#include <vxWorks.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <ioLib.h>
#include <stat.h>
#include <taskLib.h>
#include <subsys/gpio/vxbGpioLib.h>

#define NUM_GPIOS (24)

STATUS gpioTest(VOID)
    {
    int i;
    STATUS rc = OK;

    for (i = 0; i < NUM_GPIOS; i++)
        {
        rc = vxbGpioAlloc(i);
        if (rc != OK)
            {
            printf("Couldn't allocate GPIO %d\n", i);
            break;
            }
        }

    if (rc != OK)
        {
        return ERROR;
        }

    /* Set even indexed GPIOs to output, odd GPIOs to input */

    for (i = 0; i < NUM_GPIOS; i++)
        {
        UINT32 val;
        if ((i % 2) == 0)
            {
            rc = vxbGpioSetDir(i, GPIO_DIR_OUTPUT);
            if (rc != OK)
                {
                printf("Couldn't set GPIO %d direction\n", i);
                break;
                }
            val = GPIO_VALUE_LOW;
            printf("GPIO %d ouput value set to %d\n", i, val);
            rc = vxbGpioSetValue(i, val);
            if (rc != OK)
                {
                break;
                }
            }
        else
            {
            rc = vxbGpioSetDir(i, GPIO_DIR_INPUT);
            if (rc != OK)
                {
                printf("Couldn't set GPIO %d direction\n", i);
                break;
                }
            val = vxbGpioGetValue(i);
            if (val == GPIO_VALUE_INVALID)
                {
                break;
                }
            printf("GPIO %d input value is %d\n", i, val);
            }
        }

    if (rc != OK)
        {
        return ERROR;
        }


    for (i = 0; i < NUM_GPIOS; i++)
        {
        rc = vxbGpioFree(i);
        if (rc != OK)
            {
            printf("Couldn't free GPIO %d\n", i);
            }
        }

    return rc;
    }
