#include <vxWorks.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <ioLib.h>

LOCAL STATUS compareTest(int);

STATUS i2cTest(void)
    {
    STATUS rc;
    int fd0;

    fd0 = open("/eeprom/0", O_RDWR, 0);
    if (fd0 < 0)
        {
        printf("/eeprom/0 open failed\n");
        rc = ERROR;
        goto exit;
        }

    rc = compareTest(fd0);
    if (rc != OK)
        {
        printf("/eeprom/0 compare test failed\n");
        goto exit;
        }

exit:
    if (fd0 > 0)
        {
        close(fd0);
        }

    return rc;
    }

#define BUF_SIZE (8)
#define PATTERN  (0xce)

LOCAL STATUS compareTest
    (
    int fd
    )
    {
    UINT8 buf1[BUF_SIZE];
    UINT8 buf2[BUF_SIZE];
    ssize_t count;

    memset(buf1, PATTERN, BUF_SIZE);
    memset(buf2, 0, BUF_SIZE);

    count = write(fd, (const char*) buf1, BUF_SIZE);
    if (count != BUF_SIZE)
        {
        return ERROR;
        }

    count = lseek(fd, 0, SEEK_SET);
    if (count != 0)
        {
        return ERROR;
        }

    count = read(fd, (char*) buf2, BUF_SIZE);
    if (count != BUF_SIZE)
        {
        return ERROR;
        }

    if (memcmp(buf1, buf2, BUF_SIZE) != 0)
        {
        return ERROR;
        }
    return OK;
    }
